/*
//====================================================================
// FlagPenalty.
// Last Edited On 19 June 2005
// Copyright (C) 2005 L7 (L7@noobed.com)
// This program is free software; you can redistribute it and/or
// modify it under the terms of the Open Unreal Mod License.
//====================================================================
*/
class FlagPenalty extends Actor;

var int PenaltyDamage;
var int Team;

var bool bBroadcastPenaltyMessages;

/*
================
PenalizePawn.
================
*/
function PenalizePawn( int Damage, int TeamNum )
{
    PenaltyDamage = Damage;
    Team = TeamNum;

    SetTimer( 0.1, false );
}

/*
================
Timer.
================
*/
function Timer()
{
    local Pawn P;
    local Controller C;

    P = Pawn(Owner);

    if ( ( P != None ) &&
         ( P.Health > 0 ) &&
         ( P.Controller != None ) &&
         ( P.Controller.bIsPlayer ) ) {

        if ( PenaltyDamage >= P.Health ) {

            if ( ( !bBroadcastPenaltyMessages ) &&
                 ( PlayerController(P.Controller) != None ) ) {
                PlayerController(P.Controller).ReceiveLocalizedMessage( class'FlagPenaltyMessage',, P.PlayerReplicationInfo );
            } else {
                for ( C = Level.ControllerList; C != None; C = C.NextController )
                {
                    if ( PlayerController(C) != None ) {
                        PlayerController(C).ReceiveLocalizedMessage( class'FlagPenaltyMessage',, P.PlayerReplicationInfo );
                    }
                }
            }
        }

        switch ( Team )
        {
            case 0:
                P.TakeDamage( PenaltyDamage, P, P.Location, Vect(0,0,0), class'DamTypeRedFlagPenalty' );
                break;
            case 1:
                P.TakeDamage( PenaltyDamage, P, P.Location, Vect(0,0,0), class'DamTypeBlueFlagPenalty' );
                break;
            default:
                P.TakeDamage( PenaltyDamage, P, P.Location, Vect(0,0,0), class'DamTypeFlagPenalty' );
                break;
        }
    }

    Destroy();
}

defaultproperties
{
    bHidden=true
    bSkipActorPropertyReplication=true
    RemoteRole=ROLE_None
}
