/*
//====================================================================
// SissyFlag.
// Last Edited On 19 June 2005
// Copyright (C) 2005 L7 (L7@noobed.com)
// This program is free software; you can redistribute it and/or
// modify it under the terms of the Open Unreal Mod License.
//====================================================================
*/
class SissyFlag extends CTFFlag;

#exec OBJ LOAD FILE=XGameShaders.utx
#exec OBJ LOAD FILE=TeamSymbols_UT2003.utx

var MutFlagProtection MutFP;

var bool bDropped;
var vector FlagOrigin;
var FlagHitCylinder Cylinder;
var float PickupTime;

/*
================
PostBeginPlay.
================
*/
simulated function PostBeginPlay()
{
    Super.PostBeginPlay();

    LoopAnim( 'flag', 0.8 );
    SimAnim.bAnimLoop = true;
}

/*
=================
BasedHitCylinder.
=================
*/
function bool BasedHitCylinder()
{
    return ( ( MutFP.default.BasedHitRadius > 0.0 ) &&
             ( MutFP.default.BasedHitHeight > 0.0 ) );
}

/*
===================
DroppedHitCylinder.
===================
*/
function bool DroppedHitCylinder()
{
    return ( ( MutFP.default.DroppedHitRadius > 0.0 ) &&
             ( MutFP.default.DroppedHitHeight > 0.0 ) );
}

/*
================
State Home.
================
*/
Auto State Home
{
ignores SendHome, Score, Drop;

    function BeginState()
    {
        Super.BeginState();

        if ( Cylinder != None ) {
            Cylinder.Destroy();
            Cylinder = None;
        }

        OldHolder = None;
        bDropped = false;
        FlagOrigin = HomeBase.Location;

        if ( BasedHitCylinder() ) {
            Cylinder = Spawn( class'FlagHitCylinder', self,, Location, Rotation );
        }
    }
}

/*
================
State Held.
================
*/
State Held
{
ignores SetHolder, SendHome;

    function BeginState()
    {
        Super.BeginState();

        if ( Cylinder != None ) {
            Cylinder.Destroy();
            Cylinder = None;
        }

        if ( bDropped ) {
            FlagOrigin = Holder.Location;
        }

        PickupTime = Level.TimeSeconds;
    }
}

/*
================
State Dropped.
================
*/
State Dropped
{
ignores Drop;

    function BeginState()
    {
        Super.BeginState();

        if ( Cylinder != None ) {
            Cylinder.Destroy();
            Cylinder = None;
        }

        bDropped = true;

        if ( DroppedHitCylinder() ) {
            Cylinder = Spawn( class'FlagHitCylinder', self,, Location, Rotation );
        }
    }
}

defaultproperties
{
    Mesh=Mesh'XGame_rc.FlagMesh'
    DrawScale=0.9
    bDropped=false
}
